function AaoPmsGtnLink() {
	var AAO_URL_PART = "http://localhost:";
	var lastAaoSend = '';
	var dloop;
	var apiport = 0;

	function DataLoop () {
		apiport = SimVar.GetSimVarValue('L:AaoWebApiPort', 'Number');
		if (apiport != 0) {
			ExportToWeb();

			// buttonclick
			{
				var getrequestObj = {};
				getrequestObj.pullstringlvars = [];
				let tosend = { "var": "(L:AAO_PMS750_BUTTONS, String)", "value": ""};
				getrequestObj.pullstringlvars.push(tosend);
				getrequestObj.pullstringlvars.push(tosend);
				var grelxhttp = new XMLHttpRequest();
				grelxhttp.addEventListener("load", aaoDataRequestListener);
				let relurl = encodeURI(AAO_URL_PART + apiport.toString() + "/webapi/");
				grelxhttp.open("POST", relurl);
				grelxhttp.send(JSON.stringify(getrequestObj));
			}
		}
	};
	
	
	function ExportToWeb () {
		let forceUpdate = SimVar.GetSimVarValue('L:AAO_FMC_HTML_INIT', 'Number');
		let mf = document.getElementById("Mainframe");
        if (!mf){
            mf = document.getElementById("MainframeGtn");
        }
		if (mf){
			let screen = mf.innerHTML;
			if (forceUpdate == 1 || lastAaoSend !== screen){
				lastAaoSend = screen;
				let tosend = { "fname": "pms50/gtn750.html", "part": 0, "of": 1, "isvirtual": "true", "base64": window.btoa(unescape(encodeURIComponent(screen))) };
				let requestObj = {};
				requestObj.files = [];
				requestObj.files.push(tosend);
				let relxhttp = new XMLHttpRequest();
				let relurl = encodeURI(AAO_URL_PART + (apiport).toString() + "/webapi/");
				relxhttp.open("POST", relurl);
				relxhttp.send(JSON.stringify(requestObj));
				SimVar.SetSimVarValue("L:AAO_FMC_HTML_INIT", "Number", 0);
			}
		}
	};
	
	function aaoDataRequestListener (){
		let commObj = JSON.parse(this.responseText);
		let eleStr = commObj.pullstringlvars[0].value;
        let allButtons = document.getElementsByClassName("gradientButton");
		if (eleStr && eleStr.length > 0){
			var allIds = eleStr.split(',');
			for (let e = 0; e < allIds.length; e++){
				var elefire = null;
				var eleidx = allIds[e];
				if (eleidx && eleidx.length > 0){
					let ei = parseInt(eleidx);
                    if (ei < allButtons.length)
                        elefire = allButtons[ei];
				}
				if (elefire){
					var ev = new MouseEvent('mousedown', {
						'view': window,
						'bubbles': true,
						'cancelable': true,
						'screenX': (elefire.offsetLeft + 10),
						'screenY': (elefire.offsetTop + 10)
					});
					elefire.dispatchEvent(ev);
					ev = new MouseEvent('mouseup', {
						'view': window,
						'bubbles': true,
						'cancelable': true,
						'screenX': (elefire.offsetLeft + 10),
						'screenY': (elefire.offsetTop + 10)
					});
					elefire.dispatchEvent(ev);
				}
			}
		}
	};

	this.startup = function () {
		
		dloop = setInterval(DataLoop, 75);
	};
	
	this.shutdown = function () {
		clearInterval(dloop);
	};
};

var aaoPmsGtnLink = new AaoPmsGtnLink();
aaoPmsGtnLink.startup();


